/*! \file rename.c \brief Rename-Function */
//###########################################################
///	\ingroup singlefat
///	\code #include "dos.h" \endcode
///	\par Uebersicht
//###########################################################
// rename a file  - added by beta-frank - 23.04.07
//
// Quick and dirty rename function.
// This routine renames files only !
//
// Benutzung auf eigene Gefahr !
//
// Use at your own risk !
//
//#########################################################################
// Compiler: avr-gcc 3.4.5
//#########################################################################
//@{
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "dos.h"

//dos.c
#ifdef DOS_WRITE
 #ifdef DOS_RENAME
 
//###########################################################
/*!\brief Rename a file
 * \param		OldName	DOS 8.3 name of the file 
 * \param		NewName	DOS 8.3 name of the file 
 * \return 		F_OK if file could be renamed, F_ERROR if not
 */
U8 Rename(char *OldName, char *NewName)
//###########################################################
{
   if(FileFlag!=0) return F_ERROR; // don't rename if a file is open
  
   if(FindName(NewName)==FULL_MATCH) return F_ERROR; // File already exists !
   // FAT does NOT like DOUBLE filenames !
   
   if(Fopen(OldName,F_READ)==F_OK)  //To fill some usefull variables...
    {
     MakeFileName(NewName,FileName,FileExt); //Split into name and extension
     UpdateFileEntry();
     Fclose();
     return F_OK; 
    }

 return F_ERROR; // File not found
}
 #endif
#endif

//@}
